#!/usr/bin/python
# -*- coding: UTF-8 -*-
# vim: ts=4:sw=4
# --------------------
# 


from __future__ import division 
import sys,os
import Image,ImageColor
from math import ceil

def autocrop(im, box):
    bgcolor = "White" 
    bg = Image.new("RGB", (256,256), bgcolor)
    i_c = im.crop(box)
    w,h = i_c.size
    print w,h
    bg.paste( i_c, (0,0,w,h))
    return bg
#-------------------------------------------------------------------------
def main( argv ):
    image_name = argv[0]
    width = int(argv[1])
    height = int(argv[2])
    template = argv[3]

    print "Open image",image_name
    image = Image.open(image_name)
    size_x, size_y =  image.size

    step_x = int(ceil(size_x / width))
    step_y = int(ceil(size_y / height))

    print step_y, size_y, height

    if "data" not in os.listdir("."):
        os.mkdir("data")

    print"Begin process..."
    cur_w, cur_h = (0,0)
    for x in range(step_x):
        cur_h = 0
        for y in range(step_y):
            print "  o x=%d/%d - y=%d/%d"%(x+1,step_x,y+1,step_y)
            w = width
            h = height

            if cur_w + w > size_x:
                w = size_x - cur_w
            if cur_h + h > size_y:
                h = size_y - cur_h

            box = ( x*width, y*height, x*width + w, y*height + h )
#             reg = autocrop(image, box )
            reg = image.crop(box)
            reg.save( "./data/"+template%(x,y), "png" )
            cur_h += h
        cur_w += w
    print "Done"
    print "width",width, "height",height,"step_x",step_x, "step_y", step_y,"template",template

    return


####MAIN
if __name__ == "__main__":
    main(sys.argv[1:])

