# -*- coding: utf-8 -*-
# vim: ts=4:sw=4
#    This file is part of LOME.
#
#    LOME is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    LOME is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with LOME.  If not, see <http://www.gnu.org/licenses/>.
# 

# @ Main LOME entry
# Launch LOME
import sys,os,logging, traceback
sys.path.append(os.path.join(sys.path[0],'common'))
sys.path.append(os.path.join(sys.path[0],'common', 'misabstractlayer'))
sys.path.append(os.path.join(sys.path[0],'lotatc_client'))
sys.path.append(os.path.join(sys.path[0],'lotatc_server'))
from PyQt4.QtGui import *
from lotatcwnd import *
from debug import *
from constants import *

try: 
    import logging.config
    logging.config.fileConfig('logging.conf')
except:
    # Set logging config
    logging.basicConfig(level=logging.WARNING, format='%(name)s: %(message)s'
            ,filename='lotatc_client.log', filemode='w'
            )

#--- LOGGING PREFERENCES
#logging.getLogger('').setLevel(logging.WARNING)
#logging.getLogger('[RadarClient]').setLevel(logging.WARNING)
#logging.getLogger('[LotatcClient]').setLevel(logging.WARNING)

if __name__ == "__main__":
    #- Install logger
    #try:
    #    pathname = dirname( __file__ ) 
    #except:
    #    pathname = dirname( sys.argv[0] )
    pathname = os.path.abspath(dirname( sys.argv[0] ))
    app = QtGui.QApplication(sys.argv)

    #- Load traduction
    locale = QLocale.system().name();

    #-Debug
    #locale = "fr_FR"
    #locale = "en_US"
    
    translator = QTranslator()
    translator.load(QString("lome_"+locale), QString(os.path.join(pathname, "i18n")))
    app.installTranslator(translator);
    
    cst_init( app )

    try:
        window = LotatcWnd(pathname)

        window.show()
        sys.exit(app.exec_())   
    except SystemExit:
        pass
    except:
        exceptionType, exceptionValue, exceptionTraceback = sys.exc_info()
        msg_a = traceback.format_exception(exceptionType, exceptionValue, exceptionTraceback)
        msg = ""
        for m in msg_a:
            msg += m
        logging.getLogger('[ERROR]').debug(msg)
